package edu.buffalo.cse.cse486586.simplemessenger.simplemessenger;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.UnknownHostException;

import android.os.AsyncTask;
import android.os.Bundle;
import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.telephony.TelephonyManager;
import android.text.method.ScrollingMovementMethod;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.View;
import android.view.View.OnKeyListener;
import android.widget.EditText;
import android.widget.TextView;

public class MainActivity extends Activity {

	int server_port=10000;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		try {
			ServerSocket server_socket=new ServerSocket(server_port);
			new Server().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, server_socket);
		} catch (IOException e) {
			{		
				e.printStackTrace();
			}
		}
		final EditText usr_input=(EditText) findViewById(R.id.editText1);
		usr_input.setOnKeyListener(new OnKeyListener(){

			@Override
			public boolean onKey(View arg0, int arg1, KeyEvent arg2) {
				String outgoing_msg=null;
				if((arg2.getAction()==KeyEvent.ACTION_DOWN) && (arg1 == KeyEvent.KEYCODE_ENTER))
				{
					outgoing_msg=usr_input.getText().toString()+"\n";
					usr_input.setText("");
					new Client().executeOnExecutor(AsyncTask.THREAD_POOL_EXECUTOR, outgoing_msg);
				}
				return false;
			}

		});
	}

	/*	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.activity_main, menu);
		return true;
	}*/
	private class Server extends AsyncTask<ServerSocket,String,Void>{

		@Override
		protected Void doInBackground(ServerSocket... arg0) {
			Socket incoming_connection;
			BufferedReader in_buffer;
			String incoming_msg;
			try {
				while(true)
				{
					incoming_msg=null;
					incoming_connection=arg0[0].accept();
					in_buffer=new BufferedReader(new InputStreamReader(incoming_connection.getInputStream()));
					incoming_msg=in_buffer.readLine();
					publishProgress(incoming_msg);
					incoming_connection.close();
				}
			} catch (IOException e) {
				e.printStackTrace();
			}
			return null;
		}
		@Override
		protected void onProgressUpdate(String...string)
		{
			TextView msg_display = (TextView) findViewById(R.id.textView1);
			msg_display.setMovementMethod(new ScrollingMovementMethod());
			msg_display.append(string[0] + "\n");
			return;
		}

	}
	private class Client extends AsyncTask<String,Void,Void>
	{

		@Override
		protected Void doInBackground(String... arg0) {
			TelephonyManager tel =(TelephonyManager) getSystemService(Context.TELEPHONY_SERVICE);
			String portStr = tel.getLine1Number().substring(tel.getLine1Number().length() - 4);
			Integer port=0;
			if(portStr.equals("5554"))
				port=11112;
			else if(portStr.equals("5556"))
				port=11108;
			Socket outgoing_connection;
			try {
				outgoing_connection=new Socket("10.0.2.2",port);
				DataOutputStream out_buffer=new DataOutputStream(outgoing_connection.getOutputStream());
				out_buffer.writeBytes(arg0[0]);
				out_buffer.flush();
				outgoing_connection.close();
			} catch (UnknownHostException e) {
				e.printStackTrace();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return null;
		}

	}
}
